import java.io.IOException;

public class CVPacket {

	public static final int DIRECTION_LOCATION = 1;
	public static final int TIME_START = 4;
	public static final int TIME_END = 18;

	int iDirection;
	PacketTime ptTime;
	int iPayloadSize;
	String strDestinationIP;
	String strSenderIP;

    /**
     **************************************************
     *
     *
     */
     public static String getStatistics(CVPacket[] cvpaPacketList) {

		 StringBuffer strbReturn = new StringBuffer();

		 long lTotalPayload = 0;
		 int i;

		 for(i=0;i<cvpaPacketList.length;i++)
		 	lTotalPayload = lTotalPayload + cvpaPacketList[i].iPayloadSize;

		 return strbReturn.toString();

	 }//end getStatistics(CVPacket[])

    /**
     **************************************************
     *
     *
     */
	public CVPacket(String strCVString) throws IOException {

		Integer intTemp;
		String strTemp;

		if( !(strCVString.startsWith("#")) && !(strCVString.endsWith("#")) )
			throw new IOException("Not a Commview packet.");
		intTemp = new Integer(strCVString.substring(DIRECTION_LOCATION,DIRECTION_LOCATION+1));
		iDirection = intTemp.intValue();

		ptTime = computeTime(strCVString.substring(TIME_START, TIME_END));
		strSenderIP = parseIP(strCVString.substring(72,80));
		strDestinationIP = parseIP(strCVString.substring(80,88));
		strTemp = strCVString.substring( 104, (strCVString.length()-1) );
		iPayloadSize = strTemp.length();

	}//end CVPacket(String)

    /**
     **************************************************
     *
     *
     */
	protected PacketTime computeTime(String strTime) throws IOException {

		int iHour;
		int iMinute;
		int iSecond;
		int iMillisecond;
		PacketTime ptTemp;

		iMinute = Integer.parseInt(strTime.substring(0,2),16);
		iHour = Integer.parseInt(strTime.substring(4,6),16);
		iMillisecond = Integer.parseInt(strTime.substring(6,10),16);
		iSecond = Integer.parseInt(strTime.substring(12,14),16);
		ptTemp = new PacketTime(iHour,iMinute,iSecond,iMillisecond);

		return ptTemp;
	}//end computeTime(String)

    /**
     **************************************************
     *
     *
     */
	public int compare(CVPacket cvpOther) {
		return ptTime.compare(cvpOther.ptTime);

	}//end compare(CVPacket)

    /**
     **************************************************
     *
     *
     */
     public String parseIP(String strNumericIP) {

		 StringBuffer stbReturn = new StringBuffer();
		 int i;

		 for(i=0;i<strNumericIP.length();i=i+2) {
			 stbReturn.append(Integer.parseInt(strNumericIP.substring(i,i+2),16)+".");
		 }
		 return stbReturn.toString();
	 }

    /**
     **************************************************
     **************************************************
     *
     *
     */
	class PacketTime {

		int iHour;
		int iMinute;
		int iSecond;
		int iMillisecond;
		long totalTime;

	    /**
	     **************************************************
	     *
	     *
    	 */
		PacketTime(int Hour, int Minute, int Second, int Milli) {
			iHour = Hour;
			iMinute = Minute;
			iSecond = Second;
			iMillisecond = Milli;
			totalTime = iMillisecond+
						iSecond*1000+
						iMinute*60*1000+
						iHour*60*60*1000;

		}//end PacketTime(int,int,int,int)

	    /**
     	 **************************************************
    	 *
    	 *
    	 */
		int compare(PacketTime ptOther) {

			if(this.totalTime>ptOther.totalTime)
				return 1;
			else if(this.totalTime==ptOther.totalTime)
					return 0;
				 else return -1;
		}//end compare(PacketTime)
	}//end PacketTime

}//end CVPacket


