import java.io.FileNotFoundException;
import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Vector;

/**
 **************************************************
 **************************************************
 * The implementation for reading Commview packets
 * and doing some up front error checking.
 * @author Josh Winslow
 *
 */
public class CVPacketParser extends PacketParser {

   /**
	 **************************************************
	 *
	 *
     */
	public CVPacketParser(String strFilename) throws IOException {

		try {
			String[] straPackets = readFile(strFilename);
			initPacketList(straPackets);
		} catch(FileNotFoundException fnfe) {
			fnfe.printStackTrace();
			System.out.println(strFilename);
		}//end catch

	}//end PacketParser(strFileName)

   /**
     **************************************************
     *
     *
     */
    protected String[] readFile(String strFilename) throws FileNotFoundException {

		BufferedReader brPackets;
		FileInputStream fisPackets;
		String strTemp;
		String[] straPackets;
		Vector vecPackets;
		int i;

		fisPackets = new FileInputStream(strFilename);
		brPackets = new BufferedReader(new InputStreamReader(fisPackets));
		strTemp = new String();
		vecPackets = new Vector();
		while(strTemp != null) {
			if( (strTemp.startsWith("#")) && (strTemp.endsWith("#")))
				vecPackets.addElement(strTemp);
			try {
				strTemp = brPackets.readLine();
			}catch(IOException ioe) {
				ioe.printStackTrace();
				System.out.println("Error reading from file, exiting.");
				System.exit(-15);
			}//end catch
		}//end while
		straPackets = new String[vecPackets.size()];
		for(i=0;i<vecPackets.size();i++) {
			straPackets[i] = (String)vecPackets.elementAt(i);
		}//end for
		return straPackets;
	}//end readFile(String)

    /**
     **************************************************
     *
     *
     */
	protected void initPacketList(String[] straPackets) throws IOException {

		int i;

		pktaList = new CVPacket[straPackets.length];

		for(i=0;i<straPackets.length;i++)
			pktaList[i] = new CVPacket(straPackets[i]);


	}//end initPacketList(String[])
}//end PacketParser