import java.io.FileReader;
import java.io.FileWriter;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.Vector;
public class PacketDump {

	CVPacket[] cvpaPacketLists;
	String strOutputFilename;
	PacketParser ppParser;
	Vector vecFileList;
	Vector vecSenderIPList;
	Vector vecDestinationIPList;


	public PacketDump(String strFilename) throws IOException {

		if(strFilename==null)
			throw new IOException("A filename must be specified.");

		BufferedReader brFileList;
		String strFile;

		vecFileList = new Vector();
		brFileList = new BufferedReader(new FileReader(strFilename));
		strFile = brFileList.readLine();
		while(strFile!=null) {
			vecFileList.addElement(strFile);
			strFile = brFileList.readLine();
		}//end while
	}//end PacketDump(String)

	protected void parseFiles() {
		Vector vecPacketList = new Vector();
		CVPacket[] cvpaPackets;
		int iTotalLength = 0;
		for(int i=0;i<vecFileList.size();i++) {
			ppParser = new PacketParser((String)vecFileList.elementAt(i));
			cvpaPackets = ppParser.cvpaList;
			vecPacketList.addElement(cvpaPackets);
			iTotalLength += cvpaPackets.length;
		}//end for
		cvpaPacketLists = new CVPacket[iTotalLength];
		iTotalLength = 0;
		for(int i=0;i<vecPacketList.size();i++) {
			cvpaPackets = (CVPacket[])vecPacketList.elementAt(i);
			for(int j=0;j<cvpaPackets.length;j++) {
				cvpaPacketLists[iTotalLength] = cvpaPackets[j];
				iTotalLength++;
			}//end for
		}//end for
	}//end parseFiles


	public void outputPackets(CVPacketList cvplList, String strFilename)   throws IOException {

		FileWriter fwOutput;
		CVPacket[] cvpaList = cvplList.cvpaPackets;

		double dStartTime = cvpaList[0].ptTime.totalTime;

		fwOutput = new FileWriter(strFilename);
		for(int i=0;i<cvpaList.length;i++) {
			fwOutput.write(cvpaList[i].strSenderIP+",");
			fwOutput.write(cvpaList[i].strDestinationIP+",");
			fwOutput.write(cvpaList[i].iPacketSize+",");
			fwOutput.write(new Double(cvpaList[i].ptTime.totalTime-dStartTime).toString()+"\n");
			fwOutput.flush();
		}//end for
		fwOutput = new FileWriter(strFilename+"Stats");
		fwOutput.write(cvplList.getStats());
		fwOutput.flush();
	}//end outputPackets

	public void findIPs() {

		vecSenderIPList = new Vector();
		vecDestinationIPList = new Vector();

		for(int i=0;i<cvpaPacketLists.length;i++) {
			if(!vecSenderIPList.contains(cvpaPacketLists[i].strSenderIP)) {
				vecSenderIPList.addElement(cvpaPacketLists[i].strSenderIP);
				System.out.println("Sender:"+cvpaPacketLists[i].strSenderIP);
			}//end if
			if(!vecDestinationIPList.contains(cvpaPacketLists[i].strDestinationIP)) {
				vecDestinationIPList.addElement(cvpaPacketLists[i].strDestinationIP);
				System.out.println("Desitination:"+cvpaPacketLists[i].strDestinationIP);
			}//end if
		}//end for


	}//end findIPs


// DAVE LOOK IN THIS FUNCTION!!!!
	public void dumpByDelta() throws IOException {

		String strIP;
		CVPacketList cvplCur;
		CVPacket[] cvpaList;
		Vector vecBlah = new Vector();

		for(int i=0;i<vecSenderIPList.size();i++) {
			strIP = (String)vecSenderIPList.elementAt(i);
			cvplCur = new CVPacketList(cvpaPacketLists,true,strIP);
			cvpaList = cvplCur.cvpaPackets;
			for(int j=1;j<cvpaList.length;j++)
				cvpaList[j].ptTime.totalTime = cvpaList[j].ptTime.totalTime -
											   cvpaList[j-1].ptTime.totalTime;
			cvplCur.cvpaPackets=cvpaList;
			outputPackets(cvplCur,strIP+".delta");
		}//end for
	}//end dumpByDelta

	public void dumpByIP() throws IOException {

		String strIP;
		CVPacketList cvplCur;

		for(int i=0;i<vecSenderIPList.size();i++) {
			strIP = (String)vecSenderIPList.elementAt(i);
			cvplCur = new CVPacketList(cvpaPacketLists,true,strIP);
			outputPackets(cvplCur,strOutputFilename+strIP);

		}//end for


	}//end

	public static void main(String[] straArgs) {

		if(straArgs.length!=2) {
			System.out.println("The usage is:\njava PacketDump FILENAME OUTPUT_FILE\n"+
							   "where FILENAME is the name of a file that contains a list of packet files.\n"+
							   "and where OUTPUT_FILE is the name of the file in which to output the packet data.");
			System.exit(0);
		}//end if
		try {
			PacketDump pdInstance = new PacketDump(straArgs[0]);
			pdInstance.strOutputFilename = straArgs[1];
			pdInstance.parseFiles();
			pdInstance.findIPs();
			pdInstance.dumpByIP();
			pdInstance.dumpByDelta();

		} catch(IOException ioe) {
			System.out.println("Error!");
			ioe.printStackTrace();
		}//end catch
	}//end main
}//end PacketDump