/**
 **************************************************
 **************************************************
 * Packet contains the methods and attributes to deal with
 * a generic interal representation of a packet
 * It is likely that this class will be sufficent for most
 * packet types.
 * @author Josh Winslow
 *
 */
public class Packet {

	protected PacketTime ptTime;
	public int iPacketSize;
	public String strDestinationIP;
	public String strSenderIP;

    /**
     **************************************************
     **************************************************
     * A helper class to store the time
     *
     */
     class PacketTime {

		int iHour;
		int iMinute;
		int iSecond;
		double iMillisecond;
		double totalTime;

	    /**
	     **************************************************
	     * Takes the parsed ouput from the file and merges the data
	     * into a second based time variable
    	 */
		PacketTime(int Hour, int Minute, int Second, int Milli) {
			iHour = Hour*60*60;
			iMinute = Minute*60;
			iSecond = Second;
			iMillisecond = .001*Milli;
			totalTime = iMillisecond+
						iSecond+
						iMinute+
						iHour;

		}//end PacketTime(int,int,int,int)

	    /**
     	 **************************************************
    	 * Vestigial function, used to compare hour to hour, etc
    	 * @return 1 if this time is greater than passed in time,
    	 *		   0 if the times are equal
		 *		   -1 if this time is less than passed in time.
    	 */
		int compare(PacketTime ptOther) {

			if(this.totalTime>ptOther.totalTime)
				return 1;
			else if(this.totalTime==ptOther.totalTime)
					return 0;
				 else return -1;
		}//end compare(PacketTime)
	}//end PacketTime

	public double getTime() {
		return ptTime.totalTime;
	}

	public void updateTime(double d) {
		if(d<0)
			ptTime.totalTime = 999999;
		else ptTime.totalTime = d;

	}

    /**
     **************************************************
     * Compares one Packet to another based on their time value
     *
     */
	public int compare(Packet pktOther) {
		return ptTime.compare(pktOther.ptTime);

	}//end compare(Packet)

    /**
     **************************************************
     * Converts an IP address from hex to dotted decimal format
     *
     */
     public String parseIP(String strNumericIP) {

		 StringBuffer stbReturn = new StringBuffer();
		 int i;

		 for(i=0;i<strNumericIP.length();i=i+2) {
			 stbReturn.append(Integer.parseInt(strNumericIP.substring(i,i+2),16)+".");
		 }//end for
		 return stbReturn.substring(0,stbReturn.length()-1);
	 }//end parseIP(String)
}//end Packet