import java.io.FileNotFoundException;
import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Vector;

public class PacketViewer {

	CVPacket[] cvpList;

   /**
     **************************************************
     *
     *
     */
    protected String[] readFile(String strFilename) throws FileNotFoundException {

		BufferedReader brPackets;
		FileInputStream fisPackets;
		String strTemp;
		String[] straPackets;
		Vector vecPackets;
		int i;

		fisPackets = new FileInputStream(strFilename);
		brPackets = new BufferedReader(new InputStreamReader(fisPackets));
		strTemp = new String();
		vecPackets = new Vector();
		while(strTemp != null) {
			if( (strTemp.startsWith("#")) && (strTemp.endsWith("#")))
				vecPackets.addElement(strTemp);
			try {
				strTemp = brPackets.readLine();
			}catch(IOException ioe) {
				ioe.printStackTrace();
				System.out.println("Error reading from file, exiting.");
				System.exit(-15);
			}//end catch
		}//end while
		straPackets = new String[vecPackets.size()];
		for(i=0;i<vecPackets.size();i++) {
			straPackets[i] = (String)vecPackets.elementAt(i);
		}//end for
		System.out.println("There are "+straPackets.length+" packets.");
		return straPackets;
	}//end readFile(String)

    /**
     **************************************************
     *
     *
     */
	protected void initPacketList(String[] straPackets) {

		int i;

		cvpList = new CVPacket[straPackets.length];

		for(i=0;i<straPackets.length;i++)
			try {
				cvpList[i] = new CVPacket(straPackets[i]);
			} catch(IOException ioe) {
				cvpList[i]=null;
			}

	}

    /**
     **************************************************
     *
     *
     */
	public static void main(String[] straArgs) {

		PacketViewer pvInstance;
		String[] straPackets;


		pvInstance = new PacketViewer();
		try {
			straPackets = pvInstance.readFile(straArgs[0]+" "+straArgs[1]);
			pvInstance.initPacketList(straPackets);
		} catch(FileNotFoundException fnfe) {
			fnfe.printStackTrace();
		}
	}//end main(String[])

}//end PacketViewer